package cn.gyee.tamplate.util;

import com.alibaba.fastjson.JSONArray;

import java.beans.IntrospectionException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

/**

/**
 *@ClassName ObjUtil
 *@Description TODO
 *@Author 谢生杰
 *@Date 2020/9/2 11:00
 *@Version 1.0
 **/
public class ObjUtil {

    public static String objToJson(Object model) {
        Field[] field = model.getClass().getDeclaredFields(); // 获取实体类的所有属性，返回Field数组
        try {
            for (int j = 0; j < field.length; j++) { // 遍历所有属性
                String name = field[j].getName(); // 获取属性的名字
                name = name.substring(0, 1).toUpperCase() + name.substring(1); // 将属性的首字符大写，方便构造get，set方法
                String type = field[j].getGenericType().toString(); // 获取属性的类型
                if (type.equals("class java.lang.String")) { // 如果type是类类型，则前面包含"class "，后面跟类名
                    Method m = model.getClass().getMethod("get" + name);
                    String value = (String) m.invoke(model); // 调用getter方法获取属性值
                    if (value == null) {
                        m = model.getClass().getMethod("set"+name,String.class);
                        m.invoke(model, "");
                    }
                }
                if (type.equals("class java.lang.Double")) {
                    Method m = model.getClass().getMethod("get" + name);
                    Double value = (Double) m.invoke(model);
                    if (value == null) {
                        m = model.getClass().getMethod("set"+name,Double.class);
                        m.invoke(model, 0d);
                    }
                }
                if (type.equals("class java.lang.Integer")) {
                    Method m = model.getClass().getMethod("get" + name);
                    Integer value = (Integer) m.invoke(model);
                    if (value == null) {
                        m = model.getClass().getMethod("set"+name,Integer.class);
                        m.invoke(model, 0);
                    }
                }
                // 如果有需要,可以仿照上面继续进行扩充,再增加对其它类型的判断
            }
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (SecurityException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        }
        return JSONArray.toJSON(model).toString();
    }

    public static String getFlByFs(double pjfs) {
        if (pjfs >= 0 && pjfs < 0.3) {
            return "0级无风";
        } else if (pjfs >= 0.3 && pjfs < 1.6) {
            return "1级软风";
        } else if (pjfs >= 1.6 && pjfs < 3.4) {
            return "2级轻风";
        } else if (pjfs >= 3.4 && pjfs < 5.5) {
            return "3级微风";
        } else if (pjfs >= 5.5 && pjfs < 8) {
            return "4级和风";
        } else if (pjfs >= 8 && pjfs < 10.8) {
            return "5级清劲风";
        } else if (pjfs >= 10.8 && pjfs < 13.9) {
            return "6级强风";
        } else if (pjfs >= 13.9 && pjfs < 17.2) {
            return "7级疾风";
        } else if (pjfs >= 17.2 && pjfs < 20.8) {
            return "8级大风";
        } else if (pjfs >= 20.8 && pjfs < 24.5) {
            return "9级烈风";
        } else if (pjfs >= 24.5 && pjfs < 28.5) {
            return "10级狂风";
        } else if (pjfs >= 28.5 && pjfs < 32.7) {
            return "11级暴风";
        } else {
            return "台风";
        }

    }



    //测试用数据，实际应该从数据库查

}
